; VGA 320x200 256 colour PCX file reader and displayer By Z-N0TE.
; Converted from Pascal source by Mr. D. Moss. Thanks to Absent-Minded
; Professor for explaining how PCX file work.
;
; Z-N0TE -/- SiAC '94 -\- No Barriers !
;

        MOV     AX,0013h                ; Set VGA mode 320x200x256
        INT     10h                     ; Do it
        
        MOV     DI,OFFSET PALETTE       ; Set pointer to PALETTE area
        MOV     CX,768                  ; Set CX to 768 divided by 2
        MOV     AL,00                   ; Clear AL
        REP     STOSB                   ; Clear PALETTE to be black (00)
        
        CALL    SETPAL                  ; Set palette to black
        
        MOV     AX,3D00h                ; Open file read access only
        MOV     DX,OFFSET FNAME         ; Name
        INT     21h                     ; Do it
        XCHG    AX,BX                   ; Swap handle

        MOV     AX,4202h                ; Seek to end of the file
        XOR     CX,CX                   ; Clear CX
        CWD                             ; Clear DX
        INT     21h                     ; Do it

        MOV     W FSIZE,AX              ; Store filesize

        SUB     AX,768                  ; Subtract the palette

        XCHG    AX,DX                   ; Saves a byte or something
        MOV     AX,4200h                ; Seek to palette in the file
        XOR     CX,CX                   ; Clear CX
        INT     21h                     ; Do it

        MOV     AH,3Fh                  ; Read from file
        MOV     CX,768                  ; 768 bytes (palette data)
        MOV     DX,OFFSET PALETTE       ; Into PALETTE
        INT     21h                     ; Do it

        MOV     AX,4200h                ; Seek from start of file
        XOR     CX,CX                   ; Clear CX
        MOV     DX,128                  ; Past header data into picture data
        INT     21h                     ; Do it

        MOV     AX,CS                   ; Cheap way of setting up some mem
        ADD     AX,1000h                ; ...
        MOV     DS,AX                   ; ...

        MOV     AH,3Fh                  ; Read from file
        MOV     CX,W FSIZE              ; Size of the file
        SUB     CX,768+128              ; Minus the header and the palette
        XOR     DX,DX                   ; Into new DS:0000
        INT     21h                     ; Do it

        MOV     AH,3Eh                  ; Close the file as no longer needed
        INT     21h                     ; Do it

        ; PCX DISPLAYING ROUTINE
        ;~~~~~~~~~~~~~~~~~~~~~~~~
        PUSHA                           ; 286 Inst, XT users eat shit & die!

        MOV     AX,0A000                ; Where VGA RAM area is
        MOV     ES,AX                   ; ES = VGA

        XOR     AX,AX                   ; Clear some registers
        XOR     SI,SI                   ; Clear some registers
        XOR     DI,DI                   ; Clear some registers
        
        MOV     BP,64000                ; 320x200 = 64000 bytes
        CLD                             ; Clear direction flag
        
LOOP1:  MOV     CX,0001                 ; Incase its just one
        
        LODSB                           ; Load a byte
        PUSH    AX                      ; Save it for use later if needed

        AND     AL,0C0                  ; AND it, see if high bits are set
        CMP     AL,0C0                  ; Compare ...
        JNZ     OVERIT1                 ; If not JMP OVERIT1

                POP     AX              ; Restore to previous condition
                AND     AL,03F          ; How many bytes to output ?
                MOV     CX,AX           ; Set CX = HowManyBytes

                LODSB                   ; Load byte
                JMP     SHORT XX1       ; Jmp to next bit

OVERIT1:                                ; Local label
        POP     AX                      ; Restore AX (as we molested it)
XX1:    SUB     BP,CX                   ; Subtract data from how many left
        REP     STOSB                   ; Store the byte HowMany times

        OR      BP,BP                   ; Are we finished yet
        JNZ     LOOP1                   ; If not LOOP1 until done

        CALL    SETPAL                  ; Set up the palette to be right
        POPA                            ; Restore All
        
        XOR     AX,AX                   ; Clear AX
        INT     16h                     ; Wait for keypress

        MOV     AX,0003h                ; Text mode
        INT     10h                     ; Do it

        INT     20h                     ; Back to DOS

SETPAL: PUSHA                           ; Push ALL

        PUSH    CS                      ; Set CS=DS
        POP     DS                      ; ...

        MOV     SI,OFFSET PALETTE       ; Palette data
        CLD                             ; Clear direction flag

        XOR     CX,CX                   ; Clear CX

SET_LOP:MOV     AL,CL                   ; Which colour to change ?
        MOV     DX,03C8                 ; Setup register port
        OUT     DX,AL                   ; Setup right colour

        INC     DX                      ; ...

        LODSB                           ; How much RED ???
        SHR     AL,1                    ; Fix it a little
        SHR     AL,1                    ; Fix it a little
        OUT     DX,AL                   ; Set RED
        LODSB                           ; How much GREEN ???
        SHR     AL,1                    ; Fix it a little
        SHR     AL,1                    ; Fix it a little
        OUT     DX,AL                   ; Set GREEN
        LODSB                           ; How much BLUE ???
        SHR     AL,1                    ; Fix it a little
        SHR     AL,1                    ; Fix it a little
        OUT     DX,AL                   ; Set BLUE
        
        INC     CX                      ; Increase CX
        OR      CL,CL                   ; Done playing with registers yet ?
        JNZ     SET_LOP                 ; If not ...
        
        POPA                            ; Restore all
        RET                             ; Return to calling program

FNAME:  DB      'TEST.PCX',00           ; Filename of PCX file
FSIZE:  DW      0000h                   ; Temp storage of file size
PALETTE: ;DB      768 DUP(0)            ; Palette temp area (in heap area)
