{$M 16384,0,655360 A-,B-,D-,E-,F-,G+,I-,L-,N+,O-,R-,S-,V-,X-}

Program View_Pcx_File;   { VGA 320x200, 256 Colours Only !! }

Uses Dos,Crt;                                              { No Need For Graph Unit }

Const
  DataBuffer = $1400;                                      { 5K Data Buffer }

Var
  ScreenOffSet,BufferCounter,HowMany : LongInt;            { Self Explanatory }
  PcxBuffer : Array[1..DataBuffer] Of Byte;                { Declare DataBuffer Size }
  RGBs : Array[0..767] of Byte;                            { Colour Palette Storage }
  StartMode,Loop : Integer;                                { Start-Up Mode & General Loop Variable }
  Regs : Registers;                                        { Registers Variable }
  DataByte : Byte;                                         { Current Byte Being Processed }
  NumRead : Word;                                          { Temporary Variable }
  F : File;                                                { File Variable }

Procedure VGA_Mode;
Begin
  Regs.Al:=$13;  Regs.Ah:=0;                               { .Ah = Set Video Mode, .Al = 256 Colour Mode }
  Intr($10,Regs);                                          { Issue Interrupt $10 }
End;

Procedure GrayScale(StartColour,EndColour : Byte);
Begin
  Regs.Ah:=$10;  Regs.Al:=$16;                             { VGA GrayScale Summing Sub-Function }
  Regs.Bx:=StartColour;  Regs.Cx:=EndColour;               { Start & End Colours, eg. 100,255 }
  Intr($10,Regs);                                          { Issue Interrupt $10 }
End;

Procedure SetPcxPalette;
Begin
  For Loop:=0 To 767 Do RGBs[Loop]:=RGBs[Loop] SHR 2;      { Helps Set Colours Correctly }
  Regs.Ah:=$10;        Regs.Al:=$12;                       { Sets A Block of Colour Registers With A Pointer }
  Regs.Bx:=0;          Regs.Cx:=255;                       { .Bx = First Colour, .Cx = Howmany Colours }
  Regs.Es:=Seg(RGBs);  Regs.Dx:=Ofs(RGBs);                 { Point To RGB Array Table }
  Intr($10,Regs);                                          { Issue Interrupt $10 }
End;

Procedure FillBuffer;
Begin
  If (BufferCounter > DataBuffer) Then                     { Refresh Buffer ? }
  Begin
    BufferCounter:=1;                                      { Set Counter To 1 }
    BlockRead(F,PcxBuffer,SizeOf(PcxBuffer),NumRead);      { Read Chunk Of Data From .Pcx File }
  End;
  DataByte:=PcxBuffer[BufferCounter];                      { Take A Byte From The Buffer }
  Inc(BufferCounter,1);                                    { Increase Buffer Counter Position By 1 }
End;

Procedure ReadPcxFile(FileName : String);
Begin
  Assign(F,FileName);                                      { Assign .Pcx File }
  Reset(F,1);                                              { Open .Pcx File }
  Seek(F,128);                                             { Ignore .Pcx Header }
  FillChar(RGBs,SizeOf(RGBs),0);                           { Fill Colour Array With 0's }
  SetPcxPalette;                                           { Set Colour Palette To Black }
  HowMany:=0;  ScreenOffSet:=0;                            { Initialise Some Variables }
  BufferCounter:=DataBuffer + 1;                           { Force Initial Filling Of Buffer }
  While (ScreenOffSet < 64000) Do                          { While Not At End Of Screen Memory ? }
  Begin
    FillBuffer;                                            { Fill Data Buffer }
    HowMany:=1;                                            { Contiguous Bytes Set To 1 }
    If (DataByte AND $C0) = $C0 Then                       { If DataByte's Top 2 Bits Are 1 }
    Begin
      HowMany:=DataByte AND $3F;                           { It's An RLE (Run Length Encoded) Byte }
      FillBuffer;                                          { Refresh Buffer If Need Be }
    End;
    FillChar(Mem[$A000 : ScreenOffSet],HowMany,DataByte);  { Write DataByte(s) Directly To Video Memory }
    Inc(ScreenOffSet,HowMany);                             { Increase Video Memory OffSet }
  End;
  Seek(F,FileSize(F) - 768);                               { Go To EOF Less 768 Bytes }
  BlockRead(F,RGBs,SizeOf(RGBs),NumRead);                  { Read 256 x (Red,Green,Blue) Colour Triples }
  SetPcxPalette;                                           { Set Colour Palette To .Pcx's Colours }
  Close(F);                                                { Close .Pcx File }
End;

Begin                                                     
  StartMode:=LastMode;                                     { Store Start-Up Mode }
  DirectVideo:=True;                                       { Allow Direct Video Access }
  CheckBreak:=False;                                       { Turn Off Ctrl-Break Checking }
  VGA_Mode;                                                { Initialise VGA 320x200 Mode }
  ReadPcxFile('????????.Pcx');                             { Decode 320x200 .Pcx File }
  Repeat Until KeyPressed;                                 { Display .Pcx Until A Key Is Pressed }
  TextMode(StartMode);                                     { Return To Initial Start-Up Mode }
End.

Written By Mr D Moss (C) 1992

This Code Was Written Using Turbo Pascal Version 6.0
I Have Endeavoured To Make It As Fast And Understandable Without Resorting
To Any Machine Code.

Could Someone Please Tell Me How To Decode Deluxe Paint .LBM Files ?


WARNING !!
This Code Makes No Checks At All For The Following :-

  A) If 320x200 VGA Mode Is Possible On Your Machine.
  B) If The .Pcx File Actually Exists Prior To Loading.
  C) If The .Pcx File Is A VGA 320x200 Picture.


Fastest Timings Found For Loading A .Pcx File On A 80386 (20Mhz) :-

  0.98 Seconds ( HardDisk )
  0.81 Seconds ( HardDisk + RamDrive/RamDisk )

These Timings Were Compiled Using Borlands Turbo Profiler Ver 1.01
All Unnecessary Compiler Options/Keyboard Checks Were Switched Off To Obtain The
Fastest Display Speed Possible.